#ifndef _DEFINITIONS_H_
#define _DEFINITIONS_H_

#include <cpctelera.h>

#define YES	1
#define NO 	0

#define MAP_W 	80
#define MAP_H	200
#define MAP_WT  40
#define MAP_HT	50

#define CHARACTER_W	8
#define CHARACTER_H	32
#define BALA_W	4
#define BALA_H  5

#define ENTITY_W 8
#define ENTITY_H 16

#define SCREENLIMIT MAP_W - CHARACTER_W

#define MAX_STAIRS 2 // Per map
#define MAX_MINERALS 2
#define MAX_LIMITS 5

#define LEFT 0
#define RIGHT 1
#define UP 3
#define DOWN 4

#define PATRULLAR  	0
#define ATACAR		1
#define ANDAR		2
#define QUIETO		3
#define DISPARAR	4
#define MINAR 		5
#define BEBER		6
#define ABRIR		7
#define ESCALERAS	8
#define DEFENDER	9

#define BALA 	0
#define	ENEMIGO	1
#define JUGADOR 2

cpctm_declareMaskTable(g_tabletrans);

// ========== TYPES ========== //
typedef struct {
	u8 x, y;
	u8* sprite;
	u8 sd;
} TBox;

typedef struct {
	u8 x;
	u8 yu, yd;
} TStair;

typedef struct {
	u8 x, y;
	u8 n;
	u8* sprite;
} TMineral;

typedef struct {
	u8 x, y;
	u8 gate; // YES or NO
} TLimit;

typedef struct {
	u8* mapTiles;
	TBox box;
	TStair stairs[MAX_STAIRS];
	TLimit limits[MAX_LIMITS];
	u8 draw;
	u8 drawHUD;
} TMap;

typedef struct {
	u8 x[3];
	u8 y[3];
	u8* sprite;
	u8 animation;
	u8 facing;
	u8 draw;
	u8 mapN;
	u8 type;
} TSprite;

typedef struct {
	TSprite bala;
	TSprite sprite;
	u8 estado;
	u8 hp;
	u8 en;
	u8 sd;
	u8 st;
	u8 munition;
	u8 waitCount;
	u8 patrolDir;
	u8 patrolCenter;
} TCharacter;

// ========== GLOBAL VARIABLES ========== //
extern u8* g_backBuffer;
extern u8* g_screenMem;

extern TMap 		map;
extern TCharacter	player;
extern TCharacter 	enemies[6];
extern TMineral 	minerals[MAX_MINERALS];
extern u8 			AMin[4];

extern u8 final;

#endif