//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include <cpctelera.h>
#include "sprites/tileset.h"
#include "definitions.h"
#include "game.h"
#include "scenes/menu.h"
#include "scenes/endgame.h"

#define BACKBUFFER 0x8000
#define SCREENMEM  0xC000
#define STACKMEM BACKBUFFER

u8 final;

void initializeCPC() {
	// Disable firmware
	cpct_disableFirmware();

	// Set colors
	cpct_setVideoMode(0);
	cpct_setBorder(HW_BLACK);
	cpct_setPalette(g_palette,16);

	// Clean screen
	cpct_memset(g_screenMem, 0, 0x4000);
	cpct_memset(g_backBuffer, 0, 0x4000);
}

void dummy_initializeMem() __naked {
	__asm

		_g_backBuffer::
			.dw BACKBUFFER
		_g_screenMem::
			.dw SCREENMEM

	__endasm;
}

void main(void) {

	cpct_setStackLocation((void*)STACKMEM);

	initializeCPC();
	while(menu()) {
		startGame();
		if (final == 1)
			perder();
		else if (final == 2)
			ganar();

		final = 0;
	}
}
