
#include <cpctelera.h>
#include "../definitions.h"
#include "maps.h"
#include "../maps/map1.h"
#include "../maps/map2.h"
#include "../maps/map3.h"
#include "../sprites/box.h"
#include "../sprites/soda.h"
#include "../sprites/frame.h"
#include "../sprites/mineral.h"
#include "../sprites/tileset.h"


TMap map;
TMineral minerals[MAX_MINERALS];
u8 AMin[4];

// =========== Methods ================ //
void iniMap1() {
	map.mapTiles = G_MAP1;
	map.draw = 2;
	map.drawHUD = 2;

	map.box.x = 26;
	map.box.y = 84;
	map.box.sprite = g_box;
	map.box.sd = YES;

	if(AMin[0] == 1) {
		minerals[0].x = 18;
		minerals[0].y = 172;
		minerals[0].n = 1;
		minerals[0].sprite = g_mineral;
	}
	else {
		minerals[0].x = 0;
		minerals[0].y = 0;
		minerals[0].n = 0;
	}
		minerals[1].x = 0;
		minerals[1].y = 0;
		minerals[1].n = 0;

	map.stairs[0].x  = 0;
	map.stairs[0].yu = 0;
	map.stairs[0].yd = 0;
	map.stairs[1].x  = 0;
	map.stairs[1].yu = 0;
	map.stairs[1].yd = 0;

	map.limits[0].x = 0;
	map.limits[0].y = 68;
	map.limits[0].gate = NO;
	map.limits[1].x = 18;
	map.limits[1].y = 156;
	map.limits[1].gate = NO;
	map.limits[2].x = 72;
	map.limits[2].y = 68;
	map.limits[2].gate = YES;
	map.limits[3].x = 72;
	map.limits[3].y = 156;
	map.limits[3].gate = YES;
	map.limits[4].x = 0;
	map.limits[4].y = 0;
	map.limits[4].gate = NO;
}

void iniMap2() {
	map.mapTiles = G_MAP2;
	map.draw = 2;
	map.drawHUD = 2;

	map.box.x = 50;
	map.box.y = 84;
	map.box.sprite = g_box;
	map.box.sd = YES;

	if(AMin[1] == 1) {
		minerals[0].x = 60;
		minerals[0].y = 172;
		minerals[0].n = 2;
		minerals[0].sprite = g_mineral;
	}
	else {
		minerals[0].x = 0;
		minerals[0].y = 0;
		minerals[0].n = 0;
	}
		minerals[1].x = 0;
		minerals[1].y = 0;
		minerals[1].n = 0;

	map.stairs[0].x  = 42;
	map.stairs[0].yu = 68;
	map.stairs[0].yd = 156;
	map.stairs[1].x  = 0;
	map.stairs[1].yu = 0;
	map.stairs[1].yd = 0;

	map.limits[0].x = 0;
	map.limits[0].y = 68;
	map.limits[0].gate = YES;
	map.limits[1].x = 0;
	map.limits[1].y = 156;
	map.limits[1].gate = YES;
	map.limits[2].x = 60;
	map.limits[2].y = 68;
	map.limits[2].gate = NO;
	map.limits[3].x = 72;
	map.limits[3].y = 156;
	map.limits[3].gate = YES;
	map.limits[4].x = 0;
	map.limits[4].y = 0;
	map.limits[4].gate = NO;
}

void iniMap3() {
	map.mapTiles = G_MAP3;
	map.draw = 2;
	map.drawHUD = 2;

	map.box.x = 54;
	map.box.y = 84;
	map.box.sprite = g_box;
	map.box.sd = YES;

	if(AMin[2] == 1) {
		minerals[0].x = 64;
		minerals[0].y = 172;
		minerals[0].n = 3;
		minerals[0].sprite = g_mineral;
	}
	else {
		minerals[0].x = 0;
		minerals[0].y = 0;
		minerals[0].n = 0;
	}
	if(AMin[3] == 1) {
		minerals[1].x = 72;
		minerals[1].y = 32;
		minerals[1].n = 4;
		minerals[1].sprite = g_mineral;
	}
	else {
		minerals[1].x = 0;
		minerals[1].y = 0;
		minerals[1].n = 0;
	}

	map.stairs[0].x = 10;
	map.stairs[0].yu = 68;
	map.stairs[0].yd = 156;
	map.stairs[1].x = 44;
	map.stairs[1].yu = 16;
	map.stairs[1].yd = 68;

	map.limits[0].x = 8;
	map.limits[0].y = 68;
	map.limits[0].gate = NO;
	map.limits[1].x = 0;
	map.limits[1].y = 156;
	map.limits[1].gate = YES;
	map.limits[2].x = 72;
	map.limits[2].y = 16;
	map.limits[2].gate = NO;
	map.limits[3].x = 64;
	map.limits[3].y = 68;
	map.limits[3].gate = NO;
	map.limits[4].x = 64;
	map.limits[4].y = 156;
	map.limits[4].gate = NO;
}

void drawMap() {
	cpct_etm_setTileset2x4(g_tileset);
	cpct_etm_drawTilemap2x4(MAP_WT,MAP_HT,g_backBuffer,map.mapTiles);
	--map.draw;
}

void drawEntities() {
	u8* pvmem;

	// Box
	pvmem = cpct_getScreenPtr(g_backBuffer, map.box.x, map.box.y);
	cpct_drawSprite(map.box.sprite, pvmem, ENTITY_W, ENTITY_H);

	// Minerlas
	if(AMin[minerals[0].n -1]) {
		pvmem = cpct_getScreenPtr(g_backBuffer, minerals[0].x, minerals[0].y);
		cpct_drawSpriteMaskedAlignedTable(minerals[0].sprite, pvmem, ENTITY_W, ENTITY_H, g_tabletrans);
	}
	if(AMin[minerals[1].n -1]) {
		pvmem = cpct_getScreenPtr(g_backBuffer, minerals[1].x, minerals[1].y);
		cpct_drawSpriteMaskedAlignedTable(minerals[1].sprite, pvmem, ENTITY_W, ENTITY_H, g_tabletrans);
	}
}


void drawHUD() //hp = 0-10, en = 0-10, sd = YES NO
{ //3, 2     12, 6
	u8* pvmem;
	if(player.hp > 0) {
		pvmem = cpct_getScreenPtr(g_backBuffer, HP_BAR_X, HP_BAR_Y); // real HP bar
		cpct_drawSolidBox (pvmem, cpct_px2byteM0 (HP_BAR_C, HP_BAR_C), player.hp, HP_BAR_H);
	}
	if(player.hp < 10) {
		pvmem = cpct_getScreenPtr(g_backBuffer, HP_BAR_X + player.hp, HP_BAR_Y); // max HP bar
		cpct_drawSolidBox (pvmem, cpct_px2byteM0 (HP_BAR_C2, HP_BAR_C2), HP_BAR_W - player.hp, HP_BAR_H);
	}

	pvmem = cpct_getScreenPtr(g_backBuffer, HP_TXT_X, HP_TXT_Y); // HP txt
	cpct_drawStringM0 ("HP", pvmem, 14, 5);

	if(player.en > 0) {
		pvmem = cpct_getScreenPtr(g_backBuffer, EN_BAR_X, EN_BAR_Y); // real EN bar
		cpct_drawSolidBox (pvmem, cpct_px2byteM0 (EN_BAR_C, EN_BAR_C), player.en, EN_BAR_H);
	}

	if(player.en < 10) {
		pvmem = cpct_getScreenPtr(g_backBuffer, EN_BAR_X, EN_BAR_Y); // max EN bar
		cpct_drawSolidBox (pvmem, cpct_px2byteM0 (EN_BAR_C2, EN_BAR_C2), EN_BAR_W - player.en, EN_BAR_H);
	}

	pvmem = cpct_getScreenPtr(g_backBuffer, EN_TXT_X, EN_TXT_Y); // EN txt
	cpct_drawStringM0 ("EN", pvmem, 14, 5);

	if(player.sd == YES) {
		pvmem = cpct_getScreenPtr(g_backBuffer, SD_FRM_X, SD_FRM_Y); // Frame 1 (SD)
		cpct_drawSpriteMaskedAlignedTable(g_frame_1, pvmem, G_FRAME_1_W, G_FRAME_1_H, g_tabletrans);

		pvmem = cpct_getScreenPtr(g_backBuffer, SD_FRM_X, SD_FRM_Y); // Frame 1 (SD)
		cpct_drawSpriteMaskedAlignedTable(g_soda, pvmem, G_SODA_W, G_SODA_H, g_tabletrans);
	}
	else {
		cpct_etm_drawTileBox2x4 (SD_FRM_X / 2, SD_FRM_Y / 4, 4, 4, MAP_WT, g_backBuffer, map.mapTiles);

		pvmem = cpct_getScreenPtr(g_backBuffer, SD_FRM_X, SD_FRM_Y); // Frame 1 (SD)
		cpct_drawSpriteMaskedAlignedTable(g_frame_0, pvmem, G_FRAME_0_W, G_FRAME_0_H, g_tabletrans);
	}

	--map.drawHUD;
}

void nextMap() {
	if(player.sprite.mapN < 3) {
		++player.sprite.mapN;
		switch(player.sprite.mapN) {
			case 2:
				iniMap2();
				break;
			case 3:
				iniMap3();
				break;
		}
		player.sprite.x[0] = 0;
	}
}
void prevMap() {
	if(player.sprite.mapN > 1) {
		--player.sprite.mapN;
		switch(player.sprite.mapN) {
			case 1:
				iniMap1();
				break;
			case 2:
				iniMap2();
				break;
		}
		player.sprite.x[0] = SCREENLIMIT;
	}
}